use std::error::Error;
use HPGO::input::*;
// use HPGO::ir::propagate::propagate::Propagate;
use std::collections::{BTreeMap, BTreeSet, HashMap, HashSet};
use std::time::{Duration, Instant};
use HPGO::ir::hlo_ast::Param;
use HPGO::ir::propagate::ast_propagate::Context;
use HPGO::ir::propagate::vargraph::VarGraph3D;
use HPGO::ir::prune::param_priority::prioritized_params;
use HPGO::ir::*;

fn get_split_vars() -> Vec<&'static str> {
    return vec![
        "%arg3451.3452",
        "%arg3452.3453",
        "%arg3453.3454",
        "%arg3454.3455",
        "%arg3455.3456",
        "%arg3456.3457",
        "%arg3457.3458",
        "%arg3458.3459",
        "%arg3459.3460",
        "%arg3460.3461",
        "%arg3461.3462",
        "%arg3462.3463",
        "%arg3463.3464",
        "%arg3464.3465",
        "%arg3465.3466",
        "%arg3466.3467",
        "%arg3467.3468",
        "%arg3468.3469",
        "%arg3469.3470",
        "%arg3470.3471",
        "%arg3471.3472",
        "%arg3472.3473",
        "%arg3473.3474",
        "%arg3474.3475",
        "%arg3475.3476",
        "%arg3476.3477",
        "%arg3477.3478",
        "%arg3478.3479",
        "%arg3479.3480",
        "%arg3480.3481",
        "%arg3481.3482",
        "%arg3482.3483",
        "%arg3483.3484",
        "%arg3484.3485",
        "%arg3485.3486",
        "%arg3486.3487",
        "%arg3487.3488",
        "%arg3488.3489",
        "%arg3489.3490",
        "%arg3490.3491",
        "%arg3491.3492",
        "%arg3492.3493",
        "%arg3493.3494",
        "%arg3494.3495",
        "%arg3495.3496",
        "%arg3496.3497",
        "%arg3497.3498",
        "%arg3498.3499",
        "%arg3499.3500",
        "%arg3500.3501",
        "%arg3501.3502",
        "%arg3502.3503",
        "%arg3503.3504",
        "%arg3504.3505",
        "%arg3505.3506",
        "%arg3506.3507",
        "%arg3507.3508",
        "%arg3508.3509",
        "%arg3509.3510",
        "%arg3510.3511",
        "%arg3511.3512",
        "%arg3512.3513",
        "%arg3513.3514",
        "%arg3514.3515",
        "%arg3515.3516",
        "%arg3516.3517",
        "%arg3517.3518",
        "%arg3518.3519",
        "%arg3519.3520",
        "%arg3520.3521",
        "%arg3521.3522",
        "%arg3522.3523",
        "%arg3523.3524",
        "%arg3524.3525",
        "%arg3525.3526",
        "%arg3526.3527",
        "%arg3527.3528",
        "%arg3528.3529",
        "%arg3529.3530",
        "%arg3530.3531",
        "%arg3531.3532",
        "%arg3532.3533",
        "%arg3533.3534",
        "%arg3534.3535",
        "%arg3535.3536",
        "%arg3536.3537",
        "%arg3537.3538",
        "%arg3538.3539",
        "%arg3539.3540",
        "%arg3540.3541",
        "%arg3541.3542",
        "%arg3542.3543",
        "%arg3543.3544",
        "%arg3544.3545",
        "%arg3545.3546",
        "%arg3546.3547",
        "%arg3547.3548",
        "%arg3548.3549",
        "%arg3549.3550",
        "%arg3550.3551",
        "%arg3551.3552",
        "%arg3552.3553",
        "%arg3553.3554",
        "%arg3554.3555",
        "%arg3555.3556",
        "%arg3556.3557",
        "%arg3557.3558",
        "%arg3558.3559",
        "%arg3559.3560",
        "%arg3560.3561",
        "%arg3561.3562",
        "%arg3562.3563",
        "%arg3563.3564",
        "%arg3564.3565",
        "%arg3565.3566",
        "%arg3566.3567",
        "%arg3567.3568",
        "%arg3568.3569",
        "%arg3569.3570",
        "%arg3570.3571",
        "%arg3571.3572",
        "%arg3572.3573",
        "%arg3573.3574",
        "%arg3574.3575",
        "%arg3575.3576",
        "%arg3576.3577",
        "%arg3577.3578",
        "%arg3578.3579",
        "%arg3579.3580",
        "%arg3580.3581",
        "%arg3581.3582",
        "%arg3582.3583",
        "%arg3583.3584",
        "%arg3584.3585",
        "%arg3585.3586",
        "%arg3586.3587",
        "%arg3587.3588",
        "%arg3588.3589",
        "%arg3589.3590",
        "%arg3590.3591",
        "%arg3591.3592",
        "%arg3592.3593",
        "%arg3593.3594",
        "%arg3594.3595",
        "%arg3595.3596",
        "%arg3596.3597",
        "%arg3597.3598",
        "%arg3598.3599",
        "%arg3599.3600",
        "%arg3600.3601",
        "%arg3601.3602",
        "%arg3602.3603",
        "%arg3603.3604",
        "%arg3604.3605",
        "%arg3605.3606",
        "%arg3606.3607",
        "%arg3607.3608",
        "%arg3608.3609",
        "%arg3609.3610",
        "%arg3610.3611",
        "%arg3611.3612",
        "%arg3612.3613",
        "%arg3613.3614",
        "%arg3614.3615",
        "%arg3615.3616",
        "%arg3616.3617",
        "%arg3617.3618",
        "%arg3618.3619",
        "%arg3619.3620",
        "%arg3620.3621",
        "%arg3621.3622",
        "%arg3622.3623",
        "%arg3623.3624",
        "%arg3624.3625",
        "%arg3625.3626",
        "%arg3626.3627",
        "%arg3627.3628",
        "%arg3628.3629",
        "%arg3629.3630",
        "%arg3630.3631",
        "%arg3631.3632",
        "%arg3632.3633",
        "%arg3633.3634",
        "%arg3634.3635",
        "%arg3635.3636",
        "%arg3636.3637",
        "%arg3637.3638",
        "%arg3638.3639",
        "%arg3639.3640",
        "%arg3640.3641",
        "%arg3641.3642",
        "%arg3642.3643",
        "%arg3643.3644",
        "%arg3644.3645",
        "%arg3645.3646",
        "%arg3646.3647",
        "%arg3647.3648",
        "%arg3648.3649",
        "%arg3649.3650",
        "%arg3650.3651",
        "%arg3651.3652",
        "%arg3652.3653",
        "%arg3653.3654",
        "%arg3654.3655",
        "%arg3655.3656",
        "%arg3656.3657",
        "%arg3657.3658",
        "%arg3658.3659",
        "%arg3659.3660",
        "%arg3660.3661",
        "%arg3661.3662",
        "%arg3662.3663",
        "%arg3663.3664",
        "%arg3664.3665",
        "%arg3665.3666",
        "%arg3666.3667",
        "%arg3667.3668",
        "%arg3668.3669",
        "%arg3669.3670",
        "%arg3670.3671",
        "%arg3671.3672",
        "%arg3672.3673",
        "%arg3673.3674",
        "%arg3674.3675",
        "%arg3675.3676",
        "%arg3676.3677",
        "%arg3677.3678",
        "%arg3678.3679",
        "%arg3679.3680",
        "%arg3680.3681",
        "%arg3681.3682",
        "%arg3682.3683",
        "%arg3683.3684",
        "%arg3684.3685",
        "%arg3685.3686",
        "%arg3686.3687",
        "%arg3687.3688",
        "%arg3688.3689",
        "%arg3689.3690",
        "%arg3690.3691",
        "%arg3691.3692",
        "%arg3692.3693",
        "%arg3693.3694",
        "%arg3694.3695",
        "%arg3695.3696",
        "%arg3696.3697",
        "%arg3697.3698",
        "%arg3698.3699",
        "%arg3699.3700",
        "%arg3700.3701",
        "%arg3701.3702",
        "%arg3702.3703",
        "%arg3703.3704",
        "%arg3704.3705",
        "%arg3705.3706",
        "%arg3706.3707",
        "%arg3707.3708",
        "%arg3708.3709",
        "%arg3709.3710",
        "%arg3710.3711",
        "%arg3711.3712",
        "%arg3712.3713",
        "%arg3713.3714",
        "%arg3714.3715",
        "%arg3715.3716",
        "%arg3716.3717",
        "%arg3717.3718",
        "%arg3718.3719",
        "%arg3719.3720",
        "%arg3720.3721",
        "%arg3721.3722",
        "%arg3722.3723",
        "%arg3723.3724",
        "%arg3724.3725",
        "%arg3725.3726",
        "%arg3726.3727",
        "%arg3727.3728",
        "%arg3728.3729",
        "%arg3729.3730",
        "%arg3730.3731",
        "%arg3731.3732",
        "%arg3732.3733",
        "%arg3733.3734",
        "%arg3734.3735",
        "%arg3735.3736",
        "%arg3736.3737",
        "%arg3737.3738",
        "%arg3738.3739",
        "%arg3739.3740",
        "%arg3740.3741",
        "%arg3741.3742",
        "%arg3742.3743",
        "%arg3743.3744",
        "%arg3744.3745",
        "%arg3745.3746",
        "%arg3746.3747",
        "%arg3747.3748",
        "%arg3748.3749",
        "%arg3749.3750",
        "%arg3750.3751",
        "%arg3751.3752",
        "%arg3752.3753",
        "%arg3753.3754",
        "%arg3754.3755",
        "%arg3755.3756",
        "%arg3756.3757",
        "%arg3757.3758",
        "%arg3758.3759",
        "%arg3759.3760",
        "%arg3760.3761",
        "%arg3761.3762",
        "%arg3762.3763",
        "%arg3763.3764",
        "%arg3764.3765",
        "%arg3765.3766",
        "%arg3766.3767",
        "%arg3767.3768",
        "%arg3768.3769",
        "%arg3769.3770",
        "%arg3770.3771",
        "%arg3771.3772",
        "%arg3772.3773",
        "%arg3773.3774",
        "%arg3774.3775",
        "%arg3775.3776",
        "%arg3776.3777",
        "%arg3777.3778",
        "%arg3778.3779",
        "%arg3779.3780",
        "%arg3780.3781",
        "%arg3781.3782",
        "%arg3782.3783",
        "%arg3783.3784",
        "%arg3784.3785",
        "%arg3785.3786",
        "%arg3786.3787",
        "%arg3787.3788",
        "%arg3788.3789",
        "%arg3789.3790",
        "%arg3790.3791",
        "%arg3791.3792",
        "%arg3792.3793",
        "%arg3793.3794",
        "%arg3794.3795",
        "%arg3795.3796",
        "%arg3796.3797",
        "%arg3797.3798",
        "%arg3798.3799",
        "%arg3799.3800",
        "%arg3800.3801",
        "%arg3801.3802",
        "%arg3802.3803",
        "%arg3803.3804",
        "%arg3804.3805",
        "%arg3805.3806",
        "%arg3806.3807",
        "%arg3807.3808",
        "%arg3808.3809",
        "%arg3809.3810",
        "%arg3810.3811",
        "%arg3811.3812",
        "%arg3812.3813",
        "%arg3813.3814",
        "%arg3814.3815",
        "%arg3815.3816",
        "%arg3816.3817",
        "%arg3817.3818",
        "%arg3818.3819",
        "%arg3819.3820",
        "%arg3820.3821",
        "%arg3821.3822",
        "%arg3822.3823",
        "%arg3823.3824",
        "%arg3824.3825",
        "%arg3825.3826",
        "%arg3826.3827",
        "%arg3827.3828",
        "%arg3828.3829",
        "%arg3829.3830",
        "%arg3830.3831",
        "%arg3831.3832",
        "%arg3832.3833",
        "%arg3833.3834",
        "%arg3834.3835",
        "%arg3835.3836",
        "%arg3836.3837",
        "%arg3837.3838",
        "%arg3838.3839",
        "%arg3839.3840",
        "%arg3840.3841",
        "%arg3841.3842",
        "%arg3842.3843",
        "%arg3843.3844",
        "%arg3844.3845",
        "%arg3845.3846",
        "%arg3846.3847",
        "%arg3847.3848",
        "%arg3848.3849",
        "%arg3849.3850",
        "%arg3850.3851",
        "%arg3851.3852",
        "%arg3852.3853",
        "%arg3853.3854",
        "%arg3854.3855",
        "%arg3855.3856",
        "%arg3856.3857",
        "%arg3857.3858",
        "%arg3858.3859",
        "%arg3859.3860",
        "%arg3860.3861",
        "%arg3861.3862",
        "%arg3862.3863",
        "%arg3863.3864",
        "%arg3864.3865",
        "%arg3865.3866",
        "%arg3866.3867",
        "%arg3867.3868",
        "%arg3868.3869",
        "%arg3869.3870",
        "%arg3870.3871",
        "%arg3871.3872",
        "%arg3872.3873",
        "%arg3873.3874",
        "%arg3874.3875",
        "%arg3875.3876",
        "%arg3876.3877",
        "%arg3877.3878",
        "%arg3878.3879",
        "%arg3879.3880",
        "%arg3880.3881",
        "%arg3881.3882",
        "%arg3882.3883",
        "%arg3883.3884",
        "%arg3884.3885",
        "%arg3885.3886",
        "%arg3886.3887",
        "%arg3887.3888",
        "%arg3888.3889",
        "%arg3889.3890",
        "%arg3890.3891",
        "%arg3891.3892",
        "%arg3892.3893",
        "%arg3893.3894",
        "%arg3894.3895",
        "%arg3895.3896",
        "%arg3896.3897",
        "%arg3897.3898",
        "%arg3898.3899",
        "%arg3899.3900",
        "%arg3900.3901",
        "%arg3901.3902",
        "%arg3902.3903",
        "%arg3903.3904",
        "%arg3904.3905",
        "%arg3905.3906",
        "%arg3906.3907",
        "%arg3907.3908",
        "%arg3908.3909",
        "%arg3909.3910",
        "%arg3910.3911",
        "%arg3911.3912",
        "%arg3912.3913",
        "%arg3913.3914",
        "%arg3914.3915",
        "%arg3915.3916",
        "%arg3916.3917",
        "%arg3917.3918",
        "%arg3918.3919",
        "%arg3919.3920",
        "%arg3920.3921",
        "%arg3921.3922",
        "%arg3922.3923",
        "%arg3923.3924",
        "%arg3924.3925",
        "%arg3925.3926",
        "%arg3926.3927",
        "%arg3927.3928",
        "%arg3928.3929",
        "%arg3929.3930",
        "%arg3930.3931",
        "%arg3931.3932",
        "%arg3932.3933",
        "%arg3933.3934",
        "%arg3934.3935",
        "%arg3935.3936",
        "%arg3936.3937",
        "%arg3937.3938",
        "%arg3938.3939",
        "%arg3939.3940",
        "%arg3940.3941",
        "%arg3941.3942",
        "%arg3942.3943",
        "%arg3943.3944",
        "%arg3944.3945",
        "%arg3945.3946",
        "%arg3946.3947",
        "%arg3947.3948",
        "%arg3948.3949",
        "%arg3949.3950",
        "%arg3950.3951",
        "%arg3951.3952",
        "%arg3952.3953",
        "%arg3953.3954",
        "%arg3954.3955",
        "%arg3955.3956",
        "%arg3956.3957",
        "%arg3957.3958",
        "%arg3958.3959",
        "%arg3959.3960",
        "%arg3960.3961",
        "%arg3961.3962",
        "%arg3962.3963",
        "%arg3963.3964",
        "%arg3964.3965",
        "%arg3965.3966",
        "%arg3966.3967",
        "%arg3967.3968",
        "%arg3968.3969",
        "%arg3969.3970",
        "%arg3970.3971",
        "%arg3971.3972",
        "%arg3972.3973",
        "%arg3973.3974",
        "%arg3974.3975",
        "%arg3975.3976",
        "%arg3976.3977",
        "%arg3977.3978",
        "%arg3978.3979",
        "%arg3979.3980",
        "%arg3980.3981",
        "%arg3981.3982",
        "%arg3982.3983",
        "%arg3983.3984",
        "%arg3984.3985",
        "%arg3985.3986",
        "%arg3986.3987",
        "%arg3987.3988",
        "%arg3988.3989",
        "%arg3989.3990",
        "%arg3990.3991",
        "%arg3991.3992",
        "%arg3992.3993",
        "%arg3993.3994",
        "%arg3994.3995",
        "%arg3995.3996",
        "%arg3996.3997",
        "%arg3997.3998",
        "%arg3998.3999",
        "%arg3999.4000",
        "%arg4000.4001",
        "%arg4001.4002",
        "%arg4002.4003",
        "%arg4003.4004",
        "%arg4004.4005",
        "%arg4005.4006",
        "%arg4006.4007",
        "%arg4007.4008",
        "%arg4008.4009",
        "%arg4009.4010",
        "%arg4010.4011",
        "%arg4011.4012",
        "%arg4012.4013",
        "%arg4013.4014",
        "%arg4014.4015",
        "%arg4015.4016",
        "%arg4016.4017",
        "%arg4017.4018",
        "%arg4018.4019",
        "%arg4019.4020",
        "%arg4020.4021",
        "%arg4021.4022",
        "%arg4022.4023",
        "%arg4023.4024",
        "%arg4024.4025",
        "%arg4025.4026",
        "%arg4026.4027",
        "%arg4027.4028",
        "%arg4028.4029",
        "%arg4029.4030",
        "%arg4030.4031",
        "%arg4031.4032",
        "%arg4032.4033",
        "%arg4033.4034",
        "%arg4034.4035",
        "%arg4035.4036",
        "%arg4036.4037",
        "%arg4037.4038",
        "%arg4038.4039",
        "%arg4039.4040",
        "%arg4040.4041",
        "%arg4041.4042",
        "%arg4042.4043",
        "%arg4043.4044",
        "%arg4044.4045",
        "%arg4045.4046",
        "%arg4046.4047",
        "%arg4047.4048",
        "%arg4048.4049",
        "%arg4049.4050",
        "%arg4050.4051",
        "%arg4051.4052",
        "%arg4052.4053",
        "%arg4053.4054",
        "%arg4054.4055",
        "%arg4055.4056",
        "%arg4056.4057",
        "%arg4057.4058",
        "%arg4058.4059",
        "%arg4059.4060",
        "%arg4060.4061",
        "%arg4061.4062",
        "%arg4062.4063",
        "%arg4063.4064",
        "%arg4064.4065",
        "%arg4065.4066",
        "%arg4066.4067",
        "%arg4067.4068",
        "%arg4068.4069",
        "%arg4069.4070",
        "%arg4070.4071",
        "%arg4071.4072",
        "%arg4072.4073",
        "%arg4073.4074",
        "%arg4074.4075",
        "%arg4075.4076",
        "%arg4076.4077",
        "%arg4077.4078",
        "%arg4078.4079",
        "%arg4079.4080",
        "%arg4080.4081",
        "%arg4081.4082",
        "%arg4082.4083",
        "%arg4083.4084",
        "%arg4084.4085",
        "%arg4085.4086",
        "%arg4086.4087",
        "%arg4087.4088",
        "%arg4088.4089",
        "%arg4089.4090",
        "%arg4090.4091",
        "%arg4091.4092",
        "%arg4092.4093",
        "%arg4093.4094",
        "%arg4094.4095",
        "%arg4095.4096",
        "%arg4096.4097",
        "%arg4097.4098",
        "%arg4098.4099",
        "%arg4099.4100",
        "%arg4100.4101",
        "%arg4101.4102",
        "%arg4102.4103",
        "%arg4103.4104",
        "%arg4104.4105",
        "%arg4105.4106",
        "%arg4106.4107",
        "%arg4107.4108",
        "%arg4108.4109",
        "%arg4109.4110",
        "%arg4110.4111",
        "%arg4111.4112",
        "%arg4112.4113",
        "%arg4113.4114",
        "%arg4114.4115",
        "%arg4115.4116",
        "%arg4116.4117",
        "%arg4117.4118",
        "%arg4118.4119",
        "%arg4119.4120",
        "%arg4120.4121",
        "%arg4121.4122",
        "%arg4122.4123",
        "%arg4123.4124",
        "%arg4124.4125",
        "%arg4125.4126",
        "%arg4126.4127",
        "%arg4127.4128",
        "%arg4128.4129",
        "%arg4129.4130",
        "%arg4130.4131",
        "%arg4131.4132",
        "%arg4132.4133",
        "%arg4133.4134",
        "%arg4134.4135",
        "%arg4135.4136",
        "%arg4136.4137",
        "%arg4137.4138",
        "%arg4138.4139",
        "%arg4139.4140",
        "%arg4140.4141",
        "%arg4141.4142",
        "%arg4142.4143",
        "%arg4143.4144",
        "%arg4144.4145",
        "%arg4145.4146",
        "%arg4146.4147",
        "%arg4147.4148",
        "%arg4148.4149",
        "%arg4149.4150",
        "%arg4150.4151",
        "%arg4151.4152",
        "%arg4152.4153",
        "%arg4153.4154",
        "%arg4154.4155",
        "%arg4155.4156",
        "%arg4156.4157",
        "%arg4157.4158",
        "%arg4158.4159",
        "%arg4159.4160",
        "%arg4160.4161",
        "%arg4161.4162",
        "%arg4162.4163",
        "%arg4163.4164",
        "%arg4164.4165",
        "%arg4165.4166",
        "%arg4166.4167",
        "%arg4167.4168",
        "%arg4168.4169",
        "%arg4169.4170",
        "%arg4170.4171",
        "%arg4171.4172",
        "%arg4172.4173",
        "%arg4173.4174",
        "%arg4174.4175",
        "%arg4175.4176",
        "%arg4176.4177",
        "%arg4177.4178",
        "%arg4178.4179",
        "%arg4179.4180",
        "%arg4180.4181",
    ];
}

fn main() -> Result<(), Box<dyn Error>> {
    let hi: hlo_string::HLOStructuredJsonImporter = HLOModelImporter::new();
    let mut ast = hi.ImportFrom("./tests/test_data/hlo/hlo-11b.json")?;
    ast.cache_all_positional()?;
    let mut p = Context::new(ast);
    // let mut d = derive::Derivation::new_with_ast(&ast);
    // d.cache_all_derive(&ast)?;
    // let mut g = VarGraph3D::new(&d);
    // g.build_from_function("%cluster_0__XlaCompiledKernel_true__XlaNumConstantArgs_8315__XlaNumResourceArgs_2186_.94957.ComputeTask")?;
    // g.build_from_function("%fused_computation.2271.clone")?;

    // g.build_from_hlo()?;
    // g.update_graph_for_fusion()?;

    let split_vars: HashSet<&'static str> = get_split_vars().iter().cloned().collect();

    // let fn_name = "%fused_computation.2271.clone";
    let fn_name = "%cluster_0__XlaCompiledKernel_true__XlaNumConstantArgs_8315__XlaNumResourceArgs_2186_.91317";
    let f = &p.ast.functions[p.ast.func_id[fn_name]];
    let func_id = p.ast.func_id[fn_name];
    let mut target_params: Vec<Param> = vec![];
    f.params.iter().for_each(|p| {
        if split_vars.contains(p.name.as_str()) {
            target_params.push(p.clone());
            // println!("param: {}", p.name);
        }
    });
    println!(
        "got {} target params out of {} all",
        target_params.len(),
        split_vars.len()
    );

    let ordered_params = prioritized_params(&p, func_id, &target_params);

    println!(
        "Prioritized All Params: {} {}",
        target_params.len() == ordered_params.len(),
        target_params != ordered_params,
    );

    p.update_fusion_derive_cache(func_id)?;

    let now = Instant::now();
    p.get_best_split(func_id, &ordered_params)?;
    println!(
        "[propagation]\t Propagate REMT on AST Root... {}s",
        now.elapsed().as_secs()
    );
    Ok(())
}
